package disks

import (
	"context"
	"encoding/json"
	"net/http"
	"strconv"

	"repository.basistech.ru/BASIS/decort-golang-sdk/internal/validators"
)

// DepresentRequest struct to depresent disk from node
type DepresentRequest struct {
	// ID of the disk to depresent
	// Required: true
	DiskID uint64 `url:"diskId" json:"diskId" validate:"required"`

	// ID of the node to depresent disk from
	// Required: true
	NodeID uint64 `url:"nodeId" json:"nodeId" validate:"required"`
}

type wrapperDepresentRequest struct {
	DepresentRequest

	AsyncMode bool `url:"async_mode" json:"async_mode"`
}

// Depresent depresents disk from node
func (d Disks) Depresent(ctx context.Context, req DepresentRequest) (bool, error) {
	err := validators.ValidateRequest(req)
	if err != nil {
		return false, validators.ValidationErrors(validators.GetErrors(err))
	}

	url := "/cloudbroker/disks/depresent"

	wrappedReq := wrapperDepresentRequest{
		DepresentRequest: req,
		AsyncMode:        false,
	}

	res, err := d.client.DecortApiCall(ctx, http.MethodPost, url, wrappedReq)
	if err != nil {
		return false, err
	}

	result, err := strconv.ParseBool(string(res))
	if err != nil {
		return false, err
	}

	return result, nil
}

// Depresent depresents disk from node in async mode
func (d Disks) DepresentAsync(ctx context.Context, req DepresentRequest) (string, error) {
	err := validators.ValidateRequest(req)
	if err != nil {
		return "", validators.ValidationErrors(validators.GetErrors(err))
	}

	url := "/cloudbroker/disks/depresent"

	wrappedReq := wrapperDepresentRequest{
		DepresentRequest: req,
		AsyncMode:        true,
	}

	res, err := d.client.DecortApiCall(ctx, http.MethodPost, url, wrappedReq)
	if err != nil {
		return "", err
	}

	var result string
	if err := json.Unmarshal(res, &result); err != nil {
		return "", err
	}

	return result, nil
}
